// Copyright 1998-2016 Epic Games, Inc. All Rights Reserved.

#pragma once

#include "ModuleManager.h"

#if PLATFORM_ANDROID
#include "../../../Launch/Public/Android/AndroidJNI.h"
enum class AndroidKeyboardResult
{
	Changed,
	Cancelled,
	Committed
};

typedef TFunction<void(AndroidKeyboardResult, const FString &, int)> KeyboardResultFn;
#endif

class FAndroidKeyboardModule : public IModuleInterface
{
#if PLATFORM_ANDROID
	static KeyboardResultFn m_KeyboardResult;
	static int m_KeyboardHeight;
public:
	static struct _JNIEnv *ENV;
	static void OpenKeyboard(const KeyboardResultFn &rFn, const FString &rTxt, int ref, int type);
	static bool IsKeyboardOpen();
	static void HideKeyboard(int ref);
	static int GetKeyboardHeight();
	static void SetText(const FString &rStr);
	static void SetCursor(int iPos);
	static int GetCursor();
	static void CPPOnTextChange(const FString &rStr, int ref, bool bDone);
#endif
	/** IModuleInterface implementation */
	virtual void StartupModule() override;
	virtual void ShutdownModule() override;
};